﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SfDataGridDemo
{
    public class ViewModel : INotifyPropertyChanged
    {
        ObservableCollection<Employee> source;
        protected int Count = 5;
        int tem = 1;
        public static int value1 = 0;
        int k = 1;
        int num = 0;
        int comboitem = 0;
        string dateString = "5/1/1991 8:30:52 AM";

        #region public properties

        public ObservableCollection<Employee> Source
        {
            get
            {
                return source;
            }
            set
            {
                source = value;
                RaisePropertyChanged("Source");
            }
        }

        #endregion


        public ViewModel()
        {
            source = GetEmployeesDetails(Count);
        }

        public ObservableCollection<Employee> GetEmployeesDetails(int count)
        {
            var employees = new ObservableCollection<Employee>();
            for (int i = 1; i < count; i++)
            {
                employees.Add(GetEmployee(i));
            }
            return employees;
        }

        public Employee GetEmployee(int i)
        {
            DateTime birthdate = Convert.ToDateTime(dateString);
            comboitem++;
            tem++;
            if (tem > 40)
                tem = 0;
            if (comboitem > 9)
                comboitem = 0;

            return new Employee()
            {
                EmployeeID = 1000 + i,
                OrderID = i,
                ContactID = ContactDetails(),
                BirthDate = birthdate.AddDays(tem),
                SickLeaveHours = tem % 8,
                Salary = 5000 + tem,
                OrderDetails = GetOrderDetails(6),
            };
        }

        private ObservableCollection<OrderInfo> GetOrderDetails(int count)
        {
            var orders = new ObservableCollection<OrderInfo>();
            for (int i = 0; i < count; i++)
            {
                if (num > 7)
                    num = 0;
                orders.Add(Getorder());
                k += 3;
            }
            return orders;
        }

        private int ContactDetails()
        {
            int number;
            if (tem % 3 == 0)
                number = 7898789;
            else if (tem % 2 == 0)
                number = 9896781;
            else
                number = 838381;
            return number;
        }

        public OrderInfo Getorder()
        {
            k++;
            return new OrderInfo()
            {
                OrderID = 1000 + k,
                CustomerID = 700 + k,
                Quantity = tem + k,
                UnitPrice = k + 12,
                ProductDetails = GetProductDetails(3)
            };
        }
        private ObservableCollection<ProductInfo> GetProductDetails(int count)
        {
            var product = new ObservableCollection<ProductInfo>();
            for (int i = 0; i < count; i++)
            {
                product.Add(GetProduct(i));
            }
            return product;
        }

        public ProductInfo GetProduct(int i)
        {
            return new ProductInfo()
            {
                OrderID = i + 10 + k,
                ProductID = 100 + num + k,
                Discount = (100 + i + k) % 23,
                Country = countries[i]
            };
        }

        private string[] countries = new string[]
        {
            "Brazil",
             "Germany",
             "France",
             "Japan",
             "China",
             "Ireland",
             "Argentina",
             "England",
             "Brazil",
             "Germany",
             "France",
             "Japan",
             "China",
             "Ireland",
             "Argentina",
             "England",
             "Brazil",
             "Germany",
             "France",
             "Japan",
             "China",
             "Ireland",
             "Argentina",
             "England"
        };
        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string name)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }
    }

}
